"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useReport = exports._useReport = void 0;
var react_1 = require("react");
var config_1 = require("../utils/config");
function _useReport(performOnEmbed) {
    var _a = react_1.useState(null), report = _a[0], _setEmbedInstance = _a[1];
    var setEmbed = function (embedDivRef, embedConfig) {
        var errors = config_1.validateConfig(embedConfig);
        if (!errors) {
            embed(embedDivRef.current, embedConfig);
        }
        else {
            var errorString = config_1.parseConfigErrors(errors);
            throw new Error(errorString || 'invalid configuration passed');
        }
    };
    var embed = function (ref, config) {
        var reportMode = config.reportMode;
        var isCreateMode = reportMode === 'Create';
        var embedInstance;
        if (isCreateMode)
            embedInstance = window.powerbi.createReport(ref, config);
        else {
            embedInstance = window.powerbi.embed(ref, config);
        }
        if (performOnEmbed) {
            performOnEmbed(embedInstance, ref);
        }
        _setEmbedInstance(embedInstance);
    };
    return [report, setEmbed];
}
exports._useReport = _useReport;
function useReport() {
    var _a = react_1.useState(null), report = _a[0], _setEmbedInstance = _a[1];
    var setEmbed = function (ref, config) {
        var embedConfig = config_1.createEmbedConfigBasedOnEmbedType(config);
        var errors = config_1.validateConfig(embedConfig);
        if (!errors) {
            embed(ref.current, embedConfig);
        }
        else {
            var errorString = config_1.parseConfigErrors(errors);
            throw new Error(errorString || 'invalid configuration passed');
        }
    };
    var embed = function (ref, config) {
        var _embed = window.powerbi.embed(ref, config);
        var embedInstance = window.powerbi.get(ref);
        _setEmbedInstance(embedInstance);
    };
    return [report, setEmbed];
}
exports.useReport = useReport;
